'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (ast) {
  _traverser2.default.traverse(ast, {
    enter: function enter(node, parent) {
      if (node.type === 'VariableDeclaration' && node.declarations.length > 1) {
        splitDeclaration(node, parent);

        return _traverser2.default.VisitorOption.Skip;
      }
    }
  });
};

var _traverser = require('../traverser');

var _traverser2 = _interopRequireDefault(_traverser);

var _multiReplaceStatement = require('../utils/multi-replace-statement');

var _multiReplaceStatement2 = _interopRequireDefault(_multiReplaceStatement);

var _variableDeclaration = require('../syntax/variable-declaration');

var _variableDeclaration2 = _interopRequireDefault(_variableDeclaration);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function splitDeclaration(node, parent) {
  var declNodes = node.declarations.map(function (declarator) {
    return new _variableDeclaration2.default(node.kind, [declarator]);
  });

  (0, _multiReplaceStatement2.default)({
    parent: parent,
    node: node,
    replacements: declNodes,
    preserveComments: true
  });
}
module.exports = exports['default'];
